
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/maxwell.fsb" ),
	Asset("SOUND", "sound/willow.fsb"),    
        Asset( "ANIM", "anim/beard.zip" ),

		-- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/musha.zip" ),
        Asset( "ANIM", "anim/musha_full.zip" ),
Asset( "ANIM", "anim/musha_hunger.zip" ),
}

local prefabs = {
	"willowfire",
        "book_birds",
        "book_tentacles",
        "book_gardening",
        "book_sleep",
        "book_brimstone",

}


local start_inv = 
{
        "musha_egg",
       -- "frosthammer",
        "broken_frosthammer",
       -- "hat_mbunny",
       -- "hat_mcrown",
        "hat_mprincess",
        "armor_mushaa",
       -- "armor_mushab",

}
------------

    local function heal_proc(inst, data)
	if inst.components.sanity.current > 30 then
        inst.components.health:DoDelta(6)
        inst.components.sanity:DoDelta(-1)
        local fx = SpawnPrefab("shock_fx2")
    inst.SoundEmitter:PlaySound("dontstarve/common/lightningrod")
        fx.entity:SetParent(inst.entity)
	fx.Transform:SetScale(1.3, 1.3, 1.3)
        fx.Transform:SetPosition(0, -0.2, 0)
        local fx_hitanim = function()
            fx.AnimState:PlayAnimation("hit")
            fx.AnimState:PushAnimation("idle_loop")
        end
        fx:ListenForEvent("blocked", fx_hitanim, inst)
        inst.active = true
        inst:DoTaskInTime(--[[Duration]] 1, function()
            fx:RemoveEventCallback("blocked", fx_hitanim, inst)
            if inst:IsValid() then
                inst:DoTaskInTime(--[[Cooldown]] 3, function() inst.active = false 			end)
            	end
        end)
    end
end

    local function tryproc(inst)
        if not inst.active and math.random() < 0.3 then
           heal_proc(inst)
        end
    end

------------------    
local function OnHitfreeze(inst, data)
local hitfreezechance = 0.5
    local other = data.target
    if math.random() < hitfreezechance then
    if other and other.components.freezable then
        other.components.freezable:AddColdness(0.15)
        other.components.freezable:SpawnShatterFX()
    end
    if other.components.burnable and other.components.burnable:IsBurning() then
        other.components.burnable:Extinguish()
    end
end
end

local function Onfreeze(attacked, data)
        if data and data.attacker and data.attacker.components.freezable then
            data.attacker.components.freezable:AddColdness(0.2)
            data.attacker.components.freezable:SpawnShatterFX()
        end 
    end

local function OnHitlightning(inst, data)
if inst.components.sanity.current > 30 then
	do
local other = data.target
   local pos = other:GetPosition()
	GetSeasonManager():DoLightningStrike(pos)
		other.components.health:DoDelta(-60)
	inst.components.health:DoDelta(24,false,"lightning")
        inst.components.sanity:DoDelta(-10)
		end
	end
end
local function OnHitcritical(inst, data)
local hitcriticalchance = 0.15
    local other = data.target
    if math.random() < hitcriticalchance then
        other.components.health:DoDelta(-50)
       local fx = SpawnPrefab("staffcastfx")
        fx.entity:SetParent(inst.entity)
	fx.Transform:SetScale(.1, .1, .1)
        fx.Transform:SetPosition(0, 4, 0)
        local fx_hitanim = function()
            fx.AnimState:PlayAnimation("hit")
            fx.AnimState:PushAnimation("idle_loop")
        end
    end
end

local function applystats(inst)
	--local health_percent = inst.components.health:GetPercent()

    if GetClock():IsDay() then
		if inst.strength == "mighty" then	
			--inst.components.health.maxhealth = 120 
			inst.components.health:StartRegen(1, 25)
			inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1.35)
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.00)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.00)
			TUNING.SANITY_DAY_GAIN = 8/60

		elseif inst.strength == "normal" then
			--inst.components.health.maxhealth = 80 
			inst.components.health:StartRegen(1, 15)
			inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1)
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.15 )
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.15 )
			TUNING.SANITY_DAY_GAIN = 1/60

		elseif inst.strength == "wimpy" then
			inst.components.temperature.hurtrate = 0
			--inst.components.health.maxhealth = 40 
			inst.components.health:StartRegen(1, 2)
			inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 0.7)
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.3 )
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.3 )
			TUNING.SANITY_DAY_GAIN = -20/60

		end
 --inst.components.health:SetPercent(health_percent)

 	elseif GetClock():IsDusk() then
		if inst.strength == "mighty" then	
   			--inst.components.health.maxhealth = 120 
			inst.components.health:StopRegen()
			inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 0.7)
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 0.9)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 0.9)
			TUNING.SANITY_NIGHT_LIGHT = 0/60
			TUNING.SANITY_NIGHT_MID = -6/60

		elseif inst.strength == "normal" then
			--inst.components.health.maxhealth = 80 
			inst.components.health:StopRegen()
			inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1.0 )
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.05 )
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.05 )
			TUNING.SANITY_NIGHT_LIGHT = -6/60
			TUNING.SANITY_NIGHT_MID = -12/60

		elseif inst.strength == "wimpy" then
			inst.components.temperature.hurtrate = 0
			--inst.components.health.maxhealth = 40 
			inst.components.health:StartRegen(1, 2)
			inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 0.7)
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.3 )
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.3 )
			TUNING.SANITY_NIGHT_LIGHT = -20/60
			TUNING.SANITY_NIGHT_MID = -30/60

		end
 --inst.components.health:SetPercent(health_percent)

    elseif GetClock():IsNight() then
		if inst.strength == "mighty" then	
			--inst.components.health.maxhealth = 120 
			inst.components.health:StopRegen()
			inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1.35)
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 0.8)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 0.8)
			TUNING.SANITY_NIGHT_LIGHT = 0/60
			TUNING.SANITY_NIGHT_DARK = -20/60

		elseif inst.strength == "normal" then
			--inst.components.health.maxhealth = 80 
			inst.components.health:StopRegen()
			inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1.0 )
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 0.9)
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 0.9)
			TUNING.SANITY_NIGHT_LIGHT = -6/60
			TUNING.SANITY_NIGHT_DARK = -20/60

		elseif inst.strength == "wimpy" then
			inst.components.temperature.hurtrate = 0
			--inst.components.health.maxhealth = 40 
			inst.components.health:StartRegen(1, 2)
			inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 0.7 )
			inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.3 )
			inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.3 )
			TUNING.SANITY_NIGHT_LIGHT = -20/60
			TUNING.SANITY_NIGHT_DARK = -30/60

		end	

 --inst.components.health:SetPercent(health_percent)

	end

end


local function onhungerchange(inst, data)

	if inst.strength == "mighty" then
		if inst.components.hunger.current < 145 then
			
			inst.strength = "normal"
			inst.AnimState:SetBuild("musha")
inst:RemoveTag("crazy")
    inst.components.combat:SetAttackPeriod(.5)
inst.components.combat:SetAreaDamage(0, 0)
inst.components.health.fire_damage_scale = .4
    inst:RemoveEventCallback("attacked", Onfreeze)

			inst.components.talker:Say("I want to eat a snack")
		end

	elseif inst.strength == "wimpy" then
		if inst.components.hunger.current > 65 then

			inst.strength = "normal"
			inst.AnimState:SetBuild("musha")
inst:RemoveTag("crazy")
    inst.components.combat:SetAttackPeriod(.5)
inst.components.combat:SetAreaDamage(0, 0)
inst.components.health.fire_damage_scale = .4
    inst:RemoveEventCallback("attacked", Onfreeze)

			inst.components.talker:Say("Yummy !!")
		end
else

		if inst.components.hunger.current < 64 then

			inst.strength = "wimpy"
			inst.AnimState:SetBuild("musha_hunger")
inst:AddTag("crazy")
    inst.components.combat:SetAttackPeriod(.1)
inst.components.combat:SetAreaDamage(2, .25)
inst.components.health.fire_damage_scale = 1
    inst:ListenForEvent("attacked", Onfreeze)

			inst.components.talker:Say("Krrrrrr...")

		elseif inst.components.hunger.current > 146 then

			inst.strength = "mighty"
			inst.AnimState:SetBuild("musha_full")
inst:RemoveTag("crazy")
    inst.components.combat:SetAttackPeriod(.7)
inst.components.combat:SetAreaDamage(0, 0)
inst.components.health.fire_damage_scale = 0
    inst:RemoveEventCallback("attacked", Onfreeze)

			inst.components.talker:Say("feels so good")

		end

	end
	
	
	applystats(inst)
end


----------

local function updatestats(inst, data)
--
		if inst.components.health:GetPercent() < .15 and inst.components.sanity.current > 30 then
	inst.Light:Enable(true)
inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
	--inst.components.playerlightningtarget:SetHitChance(0.1)
    inst:ListenForEvent("onhitother", OnHitlightning)

		elseif inst.components.health:GetPercent() > .15 or inst.components.sanity.current < 30 then
	inst.Light:Enable(false)
inst.AnimState:SetBloomEffectHandle( "" )
	--inst.components.playerlightningtarget:SetHitChance(0.3)
    inst:RemoveEventCallback("onhitother", OnHitlightning)

end
end

local fn = function(inst)

	inst.soundsname = "willow"
    inst.entity:AddMiniMapEntity()
	inst.MiniMapEntity:SetIcon( "musha.tex" )
	inst.components.health:SetMaxHealth(120)
	inst.components.hunger:SetMax(210)
        inst.components.sanity:SetMax(120)
 inst.components.combat.damagemultiplier = TUNING.WENDY_DAMAGE_MULT
-----------
 --special
    inst.entity:AddLight()
	inst.Light:SetRadius(.3)
    inst.Light:SetFalloff(.5)
    inst.Light:SetIntensity(.3)
    inst.Light:SetColour(15/255,15/255,15/255)

        inst.procfn = function() tryproc(inst) end
        inst:ListenForEvent("attacked", inst.procfn)

	inst:AddComponent("playerlightningtarget")
    inst:ListenForEvent("onhitother", OnHitcritical)

--------------------------------------------------------------
--test bird
--[[
    inst:AddComponent("childspawner")
    inst.components.childspawner.childname = "musha_tall2"
    inst.components.childspawner:StartSpawning()
    inst.components.childspawner.maxchildren = 1
]]--

    ----------------------------------------------------------
    inst.userfunctions =    {
	updatestats = updatestats
    }

	-- eater
	inst.components.eater.strongstomach = true

--sanity
--	inst.components.sanity.night_drain_mult = 1.2
	inst.strength = "normal"

	inst:ListenForEvent( "dusktime", function() applystats(inst) end , GetWorld())
        inst:ListenForEvent( "daytime", function() applystats(inst) end , GetWorld())
        inst:ListenForEvent( "nighttime", function() applystats(inst) end , GetWorld())
         applystats(inst)

	inst:AddComponent("reader")

		---inst:AddTag("insomniac")
    inst.components.eater.stale_hunger = TUNING.WICKERBOTTOM_STALE_FOOD_HUNGER
    inst.components.eater.stale_health = TUNING.WICKERBOTTOM_STALE_FOOD_HEALTH
    inst.components.eater.spoiled_hunger = TUNING.WICKERBOTTOM_SPOILED_FOOD_HUNGER
    inst.components.eater.spoiled_health = TUNING.WICKERBOTTOM_SPOILED_FOOD_HEALTH

	local booktab = {str = STRINGS.TABS.BOOKS, sort=999, icon = "tab_book.tex"}
	inst.components.builder:AddRecipeTab(booktab)

	Recipe("book_birds", {Ingredient("papyrus", 2), Ingredient("bird_egg", 2)}, booktab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0})
	Recipe("book_gardening", {Ingredient("papyrus", 2), Ingredient("seeds", 1), Ingredient("poop", 1)}, booktab, {SCIENCE = 1})
	Recipe("book_sleep", {Ingredient("papyrus", 2), Ingredient("nightmarefuel", 2)}, booktab, {MAGIC = 2})
	Recipe("book_brimstone", {Ingredient("papyrus", 2), Ingredient("redgem", 1)}, booktab, {MAGIC = 3})
	Recipe("book_tentacles", {Ingredient("papyrus", 2), Ingredient("tentaclespots", 1)}, booktab, {SCIENCE = 3})

    inst:ListenForEvent("onhitother", OnHitfreeze)
inst:ListenForEvent("hungerdelta", onhungerchange)
inst:ListenForEvent( "healthdelta", updatestats)

    return inst

end

------------------------------------------------------------------
	

-- strings! Any "musha" below would have to be replaced by the prefab name of your character.

-- First up, the character select screen lines 
-- note: these are lower-case character name
STRINGS.CHARACTER_TITLES.musha = "Puppy Princess"
STRINGS.CHARACTER_NAMES.musha = "musha"
STRINGS.CHARACTER_DESCRIPTIONS.musha = "[Full]::happy to eat a lot. However, a weakened ability to fight. \n[Hunger]::very powerful combat skills. But crazy mind"

STRINGS.CHARACTER_QUOTES.musha = "\" I am happy princess \""

-- You can also add any kind of custom dialogue that you would like. Don't forget to make
-- categores that don't exist yet using = {}
-- note: these are UPPER-CASE charcacter name
STRINGS.CHARACTERS.musha = {}
STRINGS.CHARACTERS.musha.DESCRIBE = {}



return MakePlayerCharacter("musha", prefabs, assets, fn, start_inv)
